## nwchem 6.8+47+gitdf6c956

=== CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

cmake_minimum_required (VERSION 2.8.8)
project (GlobalArrays)

#set (GlobalArrays_VERSION_MAJOR 5)
#set (GlobalArrays_VERSION_MINOR 6)

# This project uses C,C++ and Fortran
#enable_language(CC)
#enable_language(CXX)

# where to look for special .cmake files
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake-modules")
message(status "CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")
include(GlobalArrays)

option (ENABLE_FORTRAN "Build Fortran interface" OFF)
option (ENABLE_F77 "Build Fortran interface" OFF)

if (ENABLE_F77)
  set(ENABLE_FORTRAN ON)
endif()
if (ENABLE_FORTRAN)
  set(ENABLE_F77 ON)
endif()

if (ENABLE_FORTRAN)
  if (ENABLE_CXX)
    enable_language(C CXX Fortran)
  else()
    enable_language(C Fortran)
  endif()
  set(NOFORT 0)
else()
  if (ENABLE_CXX)
    enable_language(C CXX)
  else()
    enable_language(C)
  endif()
  set(NOFORT 1)
endif()

# turn testing on
enable_testing()

find_package(MPI)

add_definitions (-DHAVE_CONFIG_H=1)

# add user configuration options
option (GA_RUNTIME "MPI runtime used to build GA" 'MPI_2SIDED')
option (MPI_TS "use MPI 2-sided protocol for communication" ON)
option (MPI_PR "use MPI progress ranks protocol for communication" OFF)
option (MPI3 "use MPI RMA protocols for communication" OFF)
option (MPI_MT "use MPI multi-threading protocols for communication" OFF)
option (MPI_PT "use MPI progress thread protocols for communication" OFF)
option (ENABLE_CXX "Build C++ interface" OFF)
if (GA_RUNTIME STREQUAL MPI_PROGRESS)
  set (MPI_TS OFF)
  set (MPI_PR ON)
elseif (GA_RUNTIME STREQUAL MPI_RMA)
  set (MPI_TS OFF)
  set (MPI3 ON)
elseif (GA_RUNTIME STREQUAL MPI_MULTITHREADED)
  set (MPI_TS OFF)
  set (MPI_MT ON)
elseif (GA_RUNTIME STREQUAL MPI_PROGRESS_THREAD)
  set (MPI_TS OFF)
  set (MPI_PT ON)
endif()
option (MSG_COMMS_MPI "Using MPI runtime for communication" ON)
option (NDEBUG "Debug option used by developers" OFF)
option (ENABLE_ARMCI_MEM_OPTION "User option for managing memory" ON)

option (ENABLE_I8 "Use 8 byte Fortran integers" OFF)
option (F2C_HIDDEN_STRING_LENGTH_AFTER_ARGS "Fortran/C interface property" ON)
option (ENABLE_BLAS "Include external BLAS and LAPACK" ON)

INCLUDE( CheckCSourceCompiles )
# Check for restrict keyword
FOREACH( ac_kw __restrict __restrict__ _Restrict restrict )
    CHECK_C_SOURCE_COMPILES(
"
typedef int * int_ptr;
int foo (int_ptr ${ac_kw} ip) {
    return ip[0];
}
int main() {
    int s[1];
    int * ${ac_kw} t = s;
    t[0] = 0;
    return foo(t); 
}   
"
    HAVE_RESTRICT )
    IF( HAVE_RESTRICT )
        SET( ac_cv_c_restrict ${ac_kw} )
        BREAK( )
    ENDIF( )
ENDFOREACH( )
IF( HAVE_RESTRICT )
    SET( restrict ${ac_cv_c_restrict} )
ELSE( )
    SET( restrict " " )
ENDIF( )

# Check for inline keyword
CHECK_C_SOURCE_COMPILES(
"
typedef int foo_t;
static inline foo_t static_foo(){return 0;}
foo_t foo(){return 0;}
int main(int argc, char *argv[]){return 0;}
"
    HAVE_INLINE_NATIVE )
IF( HAVE_INLINE_NATIVE )
ELSE ( )
    FOREACH( ac_kw __inline__ __inline )
        CHECK_C_SOURCE_COMPILES(
"
typedef int foo_t;
static ${ac_kw} foo_t static_foo(){return 0;}
foo_t foo(){return 0;}
int main(int argc, char *argv[]){return 0;}
"
        HAVE_INLINE )
        IF( HAVE_INLINE )
            SET( ac_cv_c_inline ${ac_kw} )
            BREAK( )
        ENDIF( )
    ENDFOREACH( )
    IF( HAVE_INLINE )
        SET( inline ${ac_cv_c_inline} )
    ELSE( )
        SET( inline " " )
    ENDIF( )
ENDIF( )

option (F2C_HIDDEN_STRING_LENGTH_AFTER_ARGS "Set F77 macros" ON)

if (ENABLE_FORTRAN)
  include( FortranCInterface )
  FortranCInterface_HEADER(${CMAKE_SOURCE_DIR}/f2c_cmake.h MACRO_NAMESPACE F77_FUNC_)
else()
  CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/cmake/f2c_dummy.h.in
                ${CMAKE_SOURCE_DIR}/f2c_cmake.h )
endif()

# check size of different variables
include(CheckTypeSize)
check_type_size("int" CM_SIZEOF_INT)
check_type_size("double" CM_SIZEOF_DOUBLE)
check_type_size("float" CM_SIZEOF_FLOAT)
check_type_size("long" CM_SIZEOF_LONG)
check_type_size("long double" CM_SIZEOF_LONG_DOUBLE)
check_type_size("long long" CM_SIZEOF_LONG_LONG)
check_type_size("short" CM_SIZEOF_SHORT)

# check for standard C/C++ include files
include(CheckIncludeFiles)
check_include_files("assert.h" HAVE_ASSERT_H)
check_include_files("limits.h" HAVE_LIMITS_H)
check_include_files("linux/limits.h" HAVE_LINUX_LIMITS_H)
check_include_files("malloc.h" HAVE_MALLOC_H)
check_include_files("math.h" HAVE_MATH_H)
check_include_files("stddef.h" HAVE_STDDEF_H)
check_include_files("stdint.h" HAVE_STDINT_H)
check_include_files("stdio.h" HAVE_STDIO_H)
check_include_files("stdlib.h" HAVE_STDLIB_H)
check_include_files("strings.h" HAVE_STRINGS_H)
check_include_files("string.h" HAVE_STRING_H)
check_include_files("sys/types.h" HAVE_SYS_TYPES_H)
check_include_files("unistd.h" HAVE_UNISTD_H)
check_include_files("windows.h" HAVE_WINDOWS_H)

# check for certain functions
include(CheckFunctionExists)
check_function_exists("bzero" HAVE_BZERO)

# set some flags for M$ Visual C
if (MSVC)
  add_definitions(/D NOMINMAX /D _CRT_SECURE_NO_WARNINGS /D _CRT_NONSTDC_NO_WARNINGS)
endif()
   
# hardwire various GA configuration parameters. Use convention that parameters
# are defined and set to 0 if not used
set (CYGWIN 0)
set (DECOSF 0)

# check for numerical libraries. These should set variables BLAS_FOUND and
# LAPACK_FOUND
if (ENABLE_BLAS)
find_package(BLAS)
if (BLAS_FOUND)
  set(HAVE_BLAS 1)
endif()
find_package(LAPACK)
if (LAPACK_FOUND)
  set(HAVE_LAPACK 1)
endif()
else()
  set(HAVE_BLAS 0)
endif()

message(STATUS "BLAS_LIBRARIES: ${BLAS_LIBRARIES}")
message(STATUS "LAPACK_LIBRARIES: ${LAPACK_LIBRARIES}")
if (HAVE_BLAS)
set(linalg_lib
   ${BLAS_LIBRARIES}
   ${LAPACK_LIBRARIES})
endif()
    
# check for availability of functions by seeing if small programs compile
CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
pause();
return 0;
}
"
    HAVE_PAUSE )

# check for availability of long double C-type
CHECK_C_SOURCE_COMPILES(
"
int main(int argc, char *argv[])
{
long double x;
return 0;
}
"
    HAVE_LONG_DOUBLE )

CHECK_C_SOURCE_COMPILES(
"
extern void weakf(int c);
#pragma weak weakf = __weakf
void __weakf(int c) {}
int main(int argc, char **argv) {
  weakf(0);
  return(0);
}
"
   HAVE_SYS_WEAK_ALIAS_PRAGMA )

if (HAVE_LONG_DOUBLE)
  set(MA_LONG_DOUBLE "long double")
else()
  set(MA_LONG_DOUBLE "struct {double dummy[2];}")
endif()

if (CMAKE_SYSTEM_NAME STREQUAL Linux)
  set(LINUX 1)
endif()

# hardwire memcpy and strchr since these have been standard for years
set (HAVE_MEMCPY 1)
set (HAVE_STRCHR 1)

# miscellaneous hardwired parameters (mostly not used)
set (ENABLE_CHECKPOINT 0)
set (ENABLE_PROFILING 0)
set (ENABLE_TRACE 0)
set (STATS 1)
set (USE_MALLOC 0)

# hardwire ARMCI configuration options
set (HAVE_ARMCI_GROUP_COMM 1)
set (HAVE_ARMCI_GROUP_COMM_MEMBER 0)
set (HAVE_ARMCI_INITIALIZED 1)

# suppress any checks to see if test codes run. Only check for compilation.
# use for cross-compilation situations
option (CHECK_COMPILATION_ONLY "Check compilation only" OFF)

if (ENABLE_FORTRAN)
  message(STATUS "CMAKE_Fortran_COMPILER: ${CMAKE_Fortran_COMPILER}")
  if (CMAKE_Fortran_COMPILER MATCHES "gfortran.*")
     message(STATUS "Using GNU Fortran compiler settings")
     set (F90_MODULE )
     set (F77_GETARG GETARG)
     set (F77_GETARG_ARGS "i,s")
     set (F77_GETARG_DECLS "intrinsic GETARG")
     set (F77_IARGC IARGC)
     set (F77_FLUSH flush)
     set (HAVE_F77_FLUSH 1)
  elseif (CMAKE_Fortran_COMPILER MATCHES "ifort.*")
     message(STATUS "Using Intel Fortran compiler settings")
     set (F90_MODULE )
     set (F77_GETARG GETARG)
     set (F77_GETARG_ARGS "i,s")
     set (F77_GETARG_DECLS "")
     set (F77_IARGC IARGC)
     set (F77_FLUSH flush)
     set (HAVE_F77_FLUSH 1)
  elseif (CMAKE_Fortran_COMPILER MATCHES "pgf90.*")
     message(STATUS "Using PGI Fortran compiler settings")
     set (F90_MODULE )
     set (F77_GETARG GETARG)
     set (F77_GETARG_ARGS "i,s")
     set (F77_GETARG_DECLS "")
     set (F77_IARGC IARGC)
     set (F77_FLUSH flush)
     set (HAVE_F77_FLUSH 1)
  endif()
else()
# need to set these variable even if only compiling C/C++
   set (F77_GETARG GETARG)
   set (F77_GETARG_ARGS "i,s")
   set (F77_GETARG_DECLS "external GETARG")
   set (F77_IARGC IARGC)
endif() 

# Hardwire these settings. No way to check for Fortran integer size in CMake
# (that we can find)
set (CM_SIZEOF_F77_DOUBLE 8)
set (CM_SIZEOF_F77_REAL 4)
set (CM_SIZEOF_F77_INTEGER 4)
set (F2C_INTEGER_C_TYPE int)
set (F2C_REAL_C_TYPE float)
set (F2C_DOUBLE_PRECISION_C_TYPE double)
if (ENABLE_I8)
  set (CM_SIZEOF_F77_INTEGER 8)
  set (F2C_INTEGER_C_TYPE long)
endif()
set (C_POINTER_AS_INTEGER int)
if (CMAKE_SIZEOF_VOID_P EQUAL 8)
  set (C_POINTER_AS_INTEGER long)
  if (CMAKE_SYSTEM_NAME EQUAL "Linux")
    set(NOUSE_MMAP 1)
  endif()
  set(GA_FORTRAN_ACCESS_INDEX integer*8)
else()
  set(GA_FORTRAN_ACCESS_INDEX integer*4)
endif()
set (CM_BLAS_SIZE ${CM_SIZEOF_F77_INTEGER})

# -------------------------------------------------------------
# Create include files from templates
# -------------------------------------------------------------
CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/cmake/config.h.in
                ${CMAKE_SOURCE_DIR}/config.h )
CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/cmake/farg.h.in
                ${CMAKE_SOURCE_DIR}/gaf2c/farg.h )
CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/cmake/typesf2c.h.in
                ${CMAKE_SOURCE_DIR}/gaf2c/typesf2c.h )
CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/cmake/matypes.h.in
                ${CMAKE_SOURCE_DIR}/ma/matypes.h )
CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/cmake/mafdecls.fh.in
                ${CMAKE_SOURCE_DIR}/ma/mafdecls.fh )
CONFIGURE_FILE( ${CMAKE_SOURCE_DIR}/cmake/global.fh.in
                ${CMAKE_SOURCE_DIR}/global/src/global.fh )

if (ENABLE_FORTRAN)
message(STATUS "CMAKE_COMMAND:${CMAKE_COMMAND}")
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/config.fh
    COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_SOURCE_DIR}/config.h" -D OUTPUT:PATH="${CMAKE_CURRENT_SOURCE_DIR}/config.fh" -P ${PROJECT_SOURCE_DIR}/tools/config_fh_from_h.cmake DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/config.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/config.h
  )
  add_custom_target(
    GenerateConfigFH ALL
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/config.fh
  )
endif()

# -------------------------------------------------------------
# MPI compiler
# -------------------------------------------------------------
message(STATUS "Checking MPI ...")
find_package (MPI REQUIRED)
include_directories(AFTER ${MPI_INCLUDE_PATH})

=== LinAlg/lapack+blas/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

# -------------------------------------------------------------
# LinAlg header installation
# -------------------------------------------------------------

set(LINALG_HEADERS
  xgemm.h
)

# -------------------------------------------------------------
# LINALG library installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(FORTRAN_FILES)
endif()

add_library(linalg OBJECT
  xgemm.c
  ${FORTRAN_FILES}
)

=== global/src/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(GA_FORTRAN_INTERFACE_C_FILES
    fapi.c
  )
  set(GA_FORTRAN_INTERFACE_H_FILES
    cnames.h
    global.fh
  )
  set (GA_FORTRAN_INTERFACE_F_FILES
    complex.F
  )
endif()

set(target_libraries
    ma
    elio
    dra
    eaf
    sf)

set(WAPI_FILES
  ga-wapi.h
  ga-wapidefs.h
)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR}
                    ${PROJECT_SOURCE_DIR}/gaf2c
                    ${PROJECT_SOURCE_DIR}/ma
                    ${PROJECT_SOURCE_DIR}/comex/src-armci
                    ${PROJECT_SOURCE_DIR}/tcgmsg
                    ${PROJECT_SOURCE_DIR}/LinAlg/lapack+blas
)

set(GA_FILES
  base.c
  onesided.c
  collect.c
  ghosts.c
  capi.c
  fapi.c
  datatypes.c
  decomp.c
  DP.c
  elem_alg.c
  ga_diag_seqc.c
  ga_malloc.c
  ga_profile.c
  ga_solve_seq.c
  ga_symmetr.c
  ga_trace.c
  global.nalg.c
  global.npatch.c
  global.periodic.c
  global.util.c
  hsort.scat.c
  matmul.c
  matrix.c
  nbutil.c
  peigstubs.c
  sclstubs.c
  select.c
  sparse.c
  ${GA_FORTRAN_INTERFACE_C_FILES}
  ${GA_FORTRAN_INTERFACE_F_FILES}
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/ga-wapi.h
  COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_SOURCE_DIR}/ga-papi.h" -D OUTPUT:PATH="${CMAKE_CURRENT_SOURCE_DIR}/ga-wapi.h" -P ${PROJECT_SOURCE_DIR}/tools/ga_papi_to_wapi.cmake
  DEPENDS ga-papi.h
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/ga-wapidefs.h
  COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_SOURCE_DIR}/ga-papi.h" -D OUTPUT:PATH="${CMAKE_CURRENT_SOURCE_DIR}/ga-wapidefs.h" -P ${PROJECT_SOURCE_DIR}/tools/ga_papi_to_wapidefs.cmake
  DEPENDS ga-papi.h
)

add_library(ga_src OBJECT
  ${CMAKE_CURRENT_SOURCE_DIR}/ga-wapi.h
  ${CMAKE_CURRENT_SOURCE_DIR}/ga-wapidefs.h
  ${GA_FILES}
)

if(ENABLE_FORTRAN)
  ADD_DEPENDENCIES(ga_src GenerateConfigFH)
endif()

# -------------------------------------------------------------
# Global Arrays header installation
# -------------------------------------------------------------
install(FILES
#  abstract_ops.h
#  base.h
#  cnames.h
  gacommon.h
#  gaconfig.h
  ga.h
  ga-mpi.h
  ga-papi.h
#  ga_profile.h
#  ga-wapidefs.h
  ga-wapi.h
#  global.h
#  globalp.h
#  matmul.h
  ${GA_FORTRAN_INTERFACE_H_FILES}
  DESTINATION include
)

=== global/testing/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE ${PROJECT_SOURCE_DIR}/global/src
  ${PROJECT_SOURCE_DIR}/ma ${PROJECT_SOURCE_DIR}/gaf2c
  ${PROJECT_SOURCE_DIR}/comex/src-armci
  ${PROJECT_SOURCE_DIR}/tcgmsg
  ${PROJECT_SOURCE_DIR}/LinAlg/lapack+blas
  ${PROJECT_SOURCE_DIR}/global/testing)

if (NOT MSVC)
set(ctargetlibs ${MPI_C_LIBRARIES} m)
else()
set(ctargetlibs ${MPI_C_LIBRARIES})
endif()

# -------------------------------------------------------------
# Build test executables
# -------------------------------------------------------------
add_executable (big.x big.c util.c)
add_executable (elempatch.x elempatch.c util.c)
if (LAPACK_FOUND)
add_executable (ga_lu.x ga_lu.c util.c)
endif()
add_executable (ga-mpi.x ga-mpi.c util.c)
add_executable (gatscat.x gatscat.c util.c)
add_executable (getmem.x getmem.c util.c)
#add_executable (ipc.clean.x ipc.clean.c util.c)
add_executable (lock.x lock.c util.c)
add_executable (mtest.x mtest.c util.c)

# This test uses random() and srandom() which are not available on
# Windoze
if (NOT MSVC)
   add_executable (mulmatpatchc.x mulmatpatchc.c util.c)
   ga_add_parallel_test(mulmatpatchc mulmatpatchc.x)
endif (NOT MSVC)
add_executable (normc.x normc.c util.c)
ga_add_parallel_test(normc normc.x)
add_executable (ntestc.x ntestc.c util.c)
ga_add_parallel_test(ntestc ntestc.x)
add_executable (ntestfc.x ntestfc.c util.c)
ga_add_parallel_test(ntestfc ntestfc.x)
add_executable (packc.x packc.c util.c)
ga_add_parallel_test(packc packc.x)
add_executable (patch_enumc.x patch_enumc.c util.c)
ga_add_parallel_test(patch_enumc patch_enumc.x)
add_executable (perf2.x perf2.c util.c)
ga_add_parallel_test(perf2 perf2.x)
add_executable (print.x print.c util.c)
ga_add_parallel_test(print print.x)
add_executable (scan_addc.x scan_addc.c util.c)
ga_add_parallel_test(scan_addc scan_addc.x)
add_executable (scan_copyc.x scan_copyc.c util.c)
ga_add_parallel_test(scan_copyc scan_copyc.x)
add_executable (simple_groups_commc.x simple_groups_commc.c util.c)
ga_add_parallel_test(simple_groups_commc simple_groups_commc.x)
#add_executable (sprsmatvec.x sprsmatvec.c util.c)
add_executable (testc.x testc.c util.c)
ga_add_parallel_test(testc testc.x)
add_executable (testmatmultc.x testmatmultc.c util.c)
ga_add_parallel_test(testmatmultc testmatmultc.x)
add_executable (testmult.x testmult.c util.c)
ga_add_parallel_test(testmult testmult.x)
add_executable (testmultrect.x testmultrect.c util.c)
ga_add_parallel_test(testmultrect testmultrect.x)
add_executable (unpackc.x unpackc.c util.c)
ga_add_parallel_test(unpack unpackc.x)
if (ENABLE_FORTRAN)
  add_executable (bin.x bin.F ffflush.F)
  ga_add_parallel_test(bin bin.x)
#  add_executable (blktest.x blktest.F ffflush.F)
  add_executable (d2test.x d2test.F ffflush.F util.c)
  ga_add_parallel_test(d2test d2test.x)
  add_executable (g2test.x g2test.F ffflush.F util.c)
  ga_add_parallel_test(g2test g2test.x)
  add_executable (g3test.x g3test.F ffflush.F util.c)
  ga_add_parallel_test(g3test g3test.x)
  add_executable (ga_shift.x ga_shift.F ffflush.F)
  ga_add_parallel_test(ga_shift ga_shift.x)
  add_executable (ghosts.x ghosts.F ffflush.F util.c)
  ga_add_parallel_test(ghosts ghosts.x)
  add_executable (jacobi.x jacobi.F ffflush.F)
  ga_add_parallel_test(jacobi jacobi.x)
#  add_executable (merge.x merge.F ffflush.F)
  add_executable (mir_perf1.x mir_perf1.F ffflush.F util.c)
  ga_add_parallel_test(mir_perf1 mir_perf1.x)
  add_executable (mir_perf2.x mir_perf2.F ffflush.F util.c)
  ga_add_parallel_test(mir_perf2 mir_perf2.x)
  add_executable (mmatrix.x mmatrix.F ffflush.F util.c)
  ga_add_parallel_test(mmatrix mmatrix.x)
#  add_executable (mulmatpatch.x mulmatpatch.F ffflush.F testblas.F)
  add_executable (nb2test.x nb2test.F ffflush.F util.c)
  ga_add_parallel_test(nb2test nb2test.x)
  add_executable (nbtest.x nbtest.F ffflush.F util.c)
  ga_add_parallel_test(nbtest nbtest.x)
  add_executable (ndim.x ndim.F ffflush.F util.c)
  ga_add_parallel_test(ndim ndim.x)
#  add_executable (nga-onesided.x nga-onesided.F ffflush.F util.c)
#  add_executable (nga-patch.x nga-patch.F ffflush.F util.c)
#  add_executable (nga-periodic.x nga-periodic.F ffflush.F util.c)
#  add_executable (nga-scatter.x nga-scatter.F ffflush.F)
#  add_executable (nga_test.x nga_test.F ffflush.F)
#  add_executable (ngatest.x ngatest.F ffflush.F util.c)
#  add_executable (nga-util.x nga-util.F ffflush.F)
  add_executable (patch2.x patch2.F ffflush.F)
  ga_add_parallel_test(patch2 patch2.x)
  add_executable (patch_enumf.x patch_enumf.F ffflush.F)
  ga_add_parallel_test(patch_enumf patch_enumf.x)
  add_executable (patch.x patch.F ffflush.F testblas.F)
  ga_add_parallel_test(patch patch.x)
  add_executable (perf.x perf.F ffflush.F util.c)
  ga_add_parallel_test(perf perf.x)
  add_executable (perfmod.x perfmod.F ffflush.F util.c)
  ga_add_parallel_test(perfmod perfmod.x)
  add_executable (perform.x perform.F ffflush.F util.c)
  ga_add_parallel_test(perform perform.x)
  add_executable (pg2test.x pg2test.F ffflush.F)
  ga_add_parallel_test(pg2test pg2test.x)
#  add_executable (pg2testmatmult.x pg2testmatmult.F ffflush.F util.c)
  add_executable (pgtest.x pgtest.F ffflush.F)
  ga_add_parallel_test(pgtest pgtest.x)
#  add_executable (pgtestmatmult.x pgtestmatmult.F ffflush.F util.c)
  add_executable (random.x random.F ffflush.F util.c)
  ga_add_parallel_test(random random.x)
  add_executable (scan.x scan.F ffflush.F)
  ga_add_parallel_test(scan scan.x)
  add_executable (simple_groups_comm.x simple_groups_comm.F ffflush.F)
  ga_add_parallel_test(simple_groups_comm simple_groups_comm.x)
  add_executable (simple_groups.x simple_groups.F ffflush.F)
  ga_add_parallel_test(simple_groups simple_groups.x)
  add_executable (sparse.x sparse.F ffflush.F)
  ga_add_parallel_test(sparse sparse.x)
  add_executable (sprsmatmult.x sprsmatmult.F ffflush.F)
  ga_add_parallel_test(sprsmatmult sprsmatmult.x)
  add_executable (stride.x stride.F ffflush.F)
  ga_add_parallel_test(stride stride.x)
#  add_executable (testblas.x testblas.F ffflush.F)
  add_executable (testeig.x testeig.F ffflush.F)
  ga_add_parallel_test(testeig testeig.x)
  add_executable (test.x test.F ffflush.F)
  ga_add_parallel_test(main_test test.x)
#  add_executable (testmatmult.x testmatmult.F ffflush.F util.c)
  add_executable (testsolve.x testsolve.F ffflush.F)
  ga_add_parallel_test(testsolve testsolve.x)
#  add_executable (testspd.x testspd.F ffflush.F)
  add_executable (types-test.x types-test.F ffflush.F)
  ga_add_parallel_test(types-test types-test.x)
endif()
target_link_libraries(big.x ga ${ctargetlibs})
target_link_libraries(elempatch.x ga ${ctargetlibs})
if (LAPACK_FOUND)
target_link_libraries(ga_lu.x ga ${ctargetlibs})
  ga_add_parallel_test(ga_lu ga_lu.x)
endif()
target_link_libraries(ga-mpi.x ga ${ctargetlibs})
target_link_libraries(gatscat.x ga ${ctargetlibs})
target_link_libraries(getmem.x ga ${ctargetlibs})
#target_link_libraries(ipc.clean.x ga ${ctargetlibs})
target_link_libraries(lock.x ga ${ctargetlibs})
target_link_libraries(mtest.x ga ${ctargetlibs})
if (NOT MSVC)
   target_link_libraries(mulmatpatchc.x ga ${ctargetlibs})
endif (NOT MSVC)
target_link_libraries(normc.x ga ${ctargetlibs})
target_link_libraries(ntestc.x ga ${ctargetlibs})
target_link_libraries(ntestfc.x ga ${ctargetlibs})
target_link_libraries(packc.x ga ${ctargetlibs})
target_link_libraries(patch_enumc.x ga ${ctargetlibs})
target_link_libraries(perf2.x ga ${ctargetlibs})
target_link_libraries(print.x ga ${ctargetlibs})
target_link_libraries(scan_addc.x ga ${ctargetlibs})
target_link_libraries(scan_copyc.x ga ${ctargetlibs})
target_link_libraries(simple_groups_commc.x ga ${ctargetlibs})
#target_link_libraries(sprsmatvec.x ga ${ctargetlibs})
target_link_libraries(testc.x ga ${ctargetlibs})
target_link_libraries(testmatmultc.x ga ${ctargetlibs})
target_link_libraries(testmult.x ga ${ctargetlibs})
target_link_libraries(testmultrect.x ga ${ctargetlibs})
target_link_libraries(testmult.x ga ${ctargetlibs})
target_link_libraries(unpackc.x ga ${ctargetlibs})
if (ENABLE_FORTRAN)
  target_link_libraries(bin.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(blktest.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(d2test.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(g2test.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(g3test.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(ga_shift.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(ghosts.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(jacobi.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(merge.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(mir_perf1.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(mir_perf2.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(mmatrix.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(mulmatpatch.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(nb2test.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(nbtest.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(ndim.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(nga-onesided.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(nga-patch.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(nga-periodic.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(nga-scatter.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(nga_test.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(ngatest.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(nga-util.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(patch2.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(patch_enumf.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(patch.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(perf.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(perfmod.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(perform.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(pg2test.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(pg2testmatmult.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(pgtest.x ga ${MPI_Fortran_LIBRARIES})
#  target_link_libraries(pgtestmatmult.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(random.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(scan.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(simple_groups_comm.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(simple_groups.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(sparse.x ga ${MPI_Fortran_LIBRARIES})
  target_link_libraries(sprsmatmult.x ga ${MPI_Fortran_LIBRARIES})

=== debian/changelog ===
nwchem (6.8+47+gitdf6c956-3) unstable; urgency=medium

  * Team upload
  * Use DEB_HOST_MULTIARCH instead of DEB_HOST_GNU_TYPE to fix FTBFS on i386

 -- Graham Inggs <ginggs@debian.org>  Mon, 25 Jun 2018 08:38:05 +0000

nwchem (6.8+47+gitdf6c956-2) unstable; urgency=medium

  [ Drew Parsons ]
  * Remove Build-Depends: libblacs-mpi-dev, instead use versioned
    Build-Depends: libscalapack-mpi-dev (>= 2).
    BLACS is now included in SCALAPACK 2. Closes: #875268.

  [ Michael Banck ]
  * debian/rules (DEB_HOST_GNU_TYPE): New variable.
  * debian/rules (MPI_INCLUDE): update MPI include path with
    $DEB_HOST_GNU_TYPE.
  * debian/rules (NWCHEM_LONG_PATHS): New variable, should allow for longer
    paths (Closes: #722511).
  * debian/rules (override_dh_auto_clean): Remove
    src/config/{NWCHEM_CONFIG,nwchem_config.h} after dh_auto_clean ran
    (Closes: #875267).

 -- Michael Banck <mbanck@debian.org>  Sun, 24 Jun 2018 20:04:18 +0200

nwchem (6.8+47+gitdf6c956-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/02_makefile_flags.patch: Updated.
  * debian/patches/patches/06_statfs_kfreebsd.patch: Likewise.
  * debian/patches/16_deterministic_timestamp_in_ar_workaround.patch: Removed,
    no longer needed.
  * debian/patches/17_fix_implicit_conversion_to_pointer.patch: Removed,
    applied upstream.
  * debian/patches/18_upstream_patches.patch: Likewise.
  * debian/patches/19_disable_march_native.patch: Removed, no longer needed.
  * debian/watch: Updated.
  * debian/rules: Enable scalapack.
  * debian/rules (BLAS_LIB, LAPACK_LIB): Set to actual linker flags.
  * debian/control (Build-Depends): Removed texlive-latex-base.
  * debian/nwchem.doc-base: Removed file.
  * debian/nwchem-data.install: No longer install the PDF manual.
  * debian/rules (override_dh_auto_build-indep): Target removed.

 -- Michael Banck <mbanck@debian.org>  Tue, 01 May 2018 14:17:30 +0200

nwchem (6.6+r27746-4) unstable; urgency=medium

  * debian/patches/19_disable_march_native.patch: Remove -mtune=native as well
    (Closes: #844763). 

 -- Michael Banck <mbanck@debian.org>  Sat, 19 Nov 2016 10:26:38 +0100

nwchem (6.6+r27746-3) unstable; urgency=medium

  * debian/control (Description): Move RI-MP2 method to analytical gradients
    section.
  * debian/patches/19_disable_march_native.patch: New patch, disables
    -march=native on amd64, by Edoardo Apra (Closes: #840186).

 -- Michael Banck <mbanck@debian.org>  Fri, 18 Nov 2016 12:20:28 +0100

=== debian/control ===
Source: nwchem
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: autotools-dev (>> 20100122.1~),
               csh,
               debhelper (>= 7.0.50~),
               gfortran,
               libblas-dev,
               liblapack-dev,
               libscalapack-mpi-dev (>= 2),
               mpi-default-bin,
               mpi-default-dev,
               openssh-client,
               pkg-config,
               python-dev (>= 2.6.6-3~),
               zlib1g-dev
Standards-Version: 3.9.5
X-Python-Version: current
Homepage: http://www.nwchem-sw.org
Vcs-Browser: https://salsa.debian.org/debichem-team/nwchem
Vcs-Git: https://salsa.debian.org/debichem-team/nwchem.git

Package: nwchem
Architecture: any
Depends: mpi-default-bin,
         nwchem-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: High-performance computational chemistry software
 NWChem is a computational chemistry program package.  It provides methods
 which are scalable both in their ability to treat large scientific
 computational chemistry problems efficiently, and in their use of available
 parallel computing resources from high-performance parallel supercomputers to
 conventional workstation clusters.
 .
 NWChem can handle:
 .
  * Molecular electronic structure methods using gaussian
    basis functions for high-accuracy calculations of molecules
  * Pseudopotentials plane-wave electronic structure methods for calculating
    molecules, liquids, crystals, surfaces, semi-conductors or metals
  * Ab-initio and classical molecular dynamics simulations
  * Mixed quantum-classical simulations
  * Parallel scaling to thousands of processors
 .
 Features include:
  * Molecular electronic structure methods, analytic second derivatives:
   - Restricted/unrestricted Hartree-Fock (RHF, UHF)
   - Restricted Density Functional Theory (DFT) using many local,
     non-local (gradient-corrected) or hybrid (local, non-local, and HF)
     exchange-correlation potentials
  * Molecular electronic structure methods, analytic gradients:
   - Restricted open-shell Hartree-Fock (ROHF)
   - Unrestricted Density Functional Theory (DFT)
   - Second-order Moeller-Plesset perturbation theory (MP2), using RHF and UHF
     reference
   - MP2 with resolution of the identity approximation (RI-MP2)
   - Complete active space SCF (CASSCF)
   - Time-Dependent Density Functional Theory (TDDFT)
  * Molecular electronic structure methods, single-point energies:
   - MP2 spin-component scaled approach (SCS-MP2)
   - Coupled cluster singles and doubles, triples or pertubative triples
     (CCSD, CCSDT, CCSD(T)), with RHF and UHF reference
   - Configuration interaction (CISD, CISDT, and CISDTQ)
   - Second-order approximate coupled-cluster singles doubles (CC2)
   - State-specific multireference coupled cluster methods (MRCC)
     (Brillouin-Wigner (BW-MRCC) and Mukherjee (Mk-MRCC) approaches)
  * Further molecular electronic structure features:
   - Geometry optimization including transition state searches, constraints
     and minimum energy paths (via the Nudged Elastic Band (NEB) and Zero
     Temperature String methods)
   - Vibrational frequencies
   - Equation-of-motion (EOM)-CCSD, EOM-CCSDT, EOM-CCSD(T), CC2,
     Configuration-Interaction singles (CIS), time-dependent HF (TDHF) and
     TDDFT, for excited states with RHF, UHF, RDFT, or UDFT reference
   - Solvatisation using the Conductor-like screening model (COSMO) for RHF,
     ROHF and DFT, including analytical gradients
   - Hybrid calculations using the two- and three-layer ONIOM method
   - Relativistic effects via spin-free and spin-orbit one-electron
     Douglas-Kroll and zeroth-order regular approximations (ZORA) and
     one-electron spin-orbit effects for DFT via spin-orbit potentials
  * Pseudopotential plane-wave electronic structure:
   - Pseudopotential Plane-Wave (PSPW), Projector Augmented Wave (PAW) or band
     structure methods for calculating molecules, liquids, crystals, surfaces,
     semi-conductors or metals
   - Geometry/unit cell optimization including transition state searches
   - Vibrational frequencies
   - LDA, PBE96, and PBE0 exchange-correlation potentials (restricted and
     unrestricted)
   - SIC, pert-OEP, Hartree-Fock, and hybrid functionals (restricted and
     unrestricted)
   - Hamann, Troullier-Martins and Hartwigsen-Goedecker-Hutter norm-conserving
     pseudopotentials with semicore corrections
   - Wavefunction, density, electrostatic and Wannier plotting
   - Band structure and density of states generation
  * Car-Parrinello ab-initio molecular dynamics (CPMD):
   - Constant energy and constant temperature dynamics
   - Verlet algorithm for integration
   - Geometry constraints in cartesian coordinates
  * Classical molecular dynamics (MD):
   - Single configuration energy evaluation
   - Energy minimization
   - Molecular dynamics simulation
   - Free energy simulation (multistep thermodynamic perturbation (MSTP) or
     multiconfiguration thermodynamic integration (MCTI) methods with options
     of single and/or dual topologies, double wide sampling, and separation-
     shifted scaling)
   - Force fields providing effective pair potentials, first order
     polarization, self consistent polarization, smooth particle mesh Ewald
     (SPME), periodic boundary conditions and SHAKE constraints
  * Mixed quantum-classical:
   - Mixed quantum-mechanics and molecular-mechanics (QM/MM) minimizations and
     molecular dynamics simulations
   - Quantum molecular dynamics simulation by using any of the quantum
     mechanical methods capable of returning gradients.

Package: nwchem-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: High-performance computational chemistry software (data files)
 NWChem is a computational chemistry program package.  It provides methods
 which are scalable both in their ability to treat large scientific
 computational chemistry problems efficiently, and in their use of available
 parallel computing resources from high-performance parallel supercomputers to
 conventional workstation clusters.
 .
 This package contains the basis sets, pseudopotentials and AMBER/CHARMM
 parameter files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

DEB_HOST_ARCH_BITS := $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_ARCH      := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(filter checkall,$(DEB_BUILD_OPTIONS)))
export RUN_ALL_TESTS ="yes"
endif

include /usr/share/mpi-default-dev/debian_defaults

ifeq ($(DEB_HOST_ARCH_BITS),64)
export NWCHEM_TARGET=LINUX64
export USE_SCALAPACK_I8="yes"
export BLAS_SIZE=4
export SCALAPACK=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
export BLAS_LIB="-lblas"
export LAPACK_LIB="-llapack"
export USE_64TO32="yes"
else
export NWCHEM_TARGET=LINUX
export BLAS_LIB="-lblas"
export LAPACK_LIB="-llapack"
export USE_SCALAPACK="yes"
export SCALAPACK=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
endif
ifeq ($(DEB_HOST_ARCH),armhf)
export GCC49_ARM_BROKEN="yes"
endif
export NWCHEM_TOP=${CURDIR}
export NWCHEM_MODULES="pnnl"
export NWCHEM_LONG_PATHS="y"
export PYTHONVERSION=$(shell pyversions -dv)
export PYTHONHOME=$(shell python-config --prefix)
export LIBDIR=${NWCHEM_TOP}/lib/${NWCHEM_TARGET}
export LARGE_FILES=TRUE
export FC=gfortran
export USE_MPI="y"
export USE_MPIF="y"
export USE_MPIF4="y"
ifeq ($(ARCH_DEFAULT_MPI_IMPL),mpich)
export LIBMPI=-lmpi -lmpif77
else
export LIBMPI=$(shell pkg-config mpi-fort --libs)
endif
export MPI_LIB=/usr/lib
export MPI_INCLUDE=/usr/include/${DEB_HOST_MULTIARCH}/mpi
ifneq (,$(filter ccsdtq,$(DEB_BUILD_OPTIONS)))
export CCSDTQ="yes"
endif
ifneq (,$(filter ccsdtlr,$(DEB_BUILD_OPTIONS)))
export CCSDTLR="yes"
endif
export MRCC_METHODS=y
export IPCCSD=y
export EACCSD=y
export HAS_BLAS="yes"
export BLASOPT=-lblas -llapack
export BLACS=$(SCALAPACK)
export ARMCI_NETWORK=SOCKETS
export GA_COPT=-g -O2
export ARMCI_COPT=-g -O2
export USE_ARUR="yes"

%:
	dh $@ --with autotools_dev,python2 --parallel

override_dh_auto_build-arch:
	mkdir -p $(CURDIR)/bin/${NWCHEM_TARGET}
	(cd $(CURDIR)/src && NWCHEM_TOP=$(CURDIR) make nwchem_config)
ifeq ($(DEB_HOST_ARCH_BITS),64)
	(cd $(CURDIR)/src && make 64_to_32)
	find src -name include_stamp | xargs rm -f
	find src -name dependencies | xargs rm -f
endif
	(cd $(CURDIR)/src && make)
	(cd $(CURDIR)/src/util && make)
	(cd $(CURDIR)/src && make link)
ifeq ($(DEB_HOST_ARCH_BITS),64)
	(cd $(CURDIR)/src && make 32_to_64)
endif

override_dh_auto_clean:
	dh_testdir
	-(cd $(CURDIR)/src && make realclean)
	-(cd $(CURDIR)/doc && make realclean)
	rm -rf $(CURDIR)/bin $(CURDIR)/lib $(CURDIR)/src/tools/lib 
	rm -rf $(CURDIR)/QA/scratchdir $(CURDIR)/QA/testoutputs
	rm -f src/util/util_version.F src/stubs.F src/util/util_module_avail.F
	find $(CURDIR) -name "*.stamp" | xargs rm -f
	dh_auto_clean
	rm -f src/config/NWCHEM_CONFIG src/config/nwchem_config.h

export RUNTESTS=$(CURDIR)/QA/runtests.mpi.unix 
export NWCHEM_EXECUTABLE=${NWCHEM_TOP}/bin/${NWCHEM_TARGET}/nwchem
export NWCHEM_BASIS_LIBRARY=${NWCHEM_TOP}/src/basis/libraries/
export NWCHEM_NWPW_LIBRARY=${NWCHEM_TOP}/src/nwpw/libraryps/

override_dh_auto_test:
	dh_testdir
	-(cd $(CURDIR)/QA && if [ "$(RUN_ALL_TESTS)" = "yes" ]; then \
	   ../debian/testsuite all; else ../debian/testsuite; fi)

=== debian/watch ===
version=3 
opts=uversionmangle=s/(\d+).(\d+)-(\d+)-g([a-f0-9]{7})/$1.$2+$3+git$4/,filenamemangle=s#.*nwchem-.*release.revision-v(\d+).(\d+)-(\d+)-g([a-f0-9]{7})-src\..*\.tar\.bz2#nwchem-$1.$2+$3+git$4.tar.bz2#g \
https://github.com/nwchemgit/nwchem/releases .*/download/.*/nwchem-.*release.revision-v([\d.-]+-g[a-z0-9]+)-src\..*\.tar\.bz2

## nwchem 6.8.1

=== debian/changelog ===
nwchem (6.8.1-5) unstable; urgency=medium

  * Team upload
  * Fix clean target
    Closes: #924817

 -- Andreas Tille <tille@debian.org>  Mon, 25 Mar 2019 09:52:20 +0100

nwchem (6.8.1-4) unstable; urgency=medium

  * debian/patches/15_testsuite_print_output_on_failure.patch: Fixed patch. 
  * debian/testsuite: Added rt_tddft_dimer_charge testcase. 

 -- Michael Banck <mbanck@debian.org>  Mon, 21 Jan 2019 23:29:56 +0100

nwchem (6.8.1-3) unstable; urgency=medium

  * debian/rules (GA_COPT, ARMCI_COPT): Removed, no longer needed.
  * debian/testsuite: Add -e flag to csh shebang, so that it exits on failure
    and rearrange tests so that they are all run in one command.
  * debian/control (Build-Depends): Bump libglobalarrays-dev version
    requirement to 5.7-4.
  * debian/tests: Add autopkgtests.
  * debian/testsuite: Comment out numerically unstable or currently failing
    tests.

 -- Michael Banck <mbanck@debian.org>  Sun, 20 Jan 2019 20:58:56 +0100

nwchem (6.8.1-2) unstable; urgency=medium

  * debian/rules (BLAS_SIZE): Set to 4 on all architectures. Closes: #918003.
  * debian/rules (USE_SCALAPACK_I8): Removed.

 -- Michael Banck <mbanck@debian.org>  Wed, 02 Jan 2019 15:54:31 +0100

nwchem (6.8.1-1) unstable; urgency=medium

  * New upstream point release.
  * debian/patches/03_hurd-i386_define_path_max.patch: Removed global arrays
    patch, no longer neded.
  * debian/patches/06_statfs_kfreebsd.patch: Likewise.
  * debian/patches/07_ga_target_force_linux.patch: Likewise.
  * debian/patches/11_fix_armci_locks.patch: Likewise.
  * debian/patches/12_pythonlib_multiarch_path.patch: Removed, applied
    upstream.
  * debian/patches/20_glibc-2.28_fix.patch: Likewise.
  * debian/patches/02_makefile_flags.patch: Updated.
  * debian/patches/04_show_testsuite_diff_output.patch: Refreshed.
  * debian/control (Build-Depends): Added libarmci-mpi-dev and
    libglobalarrays-dev.
  * debian/watch: Updated.
  * debian/rules (EXTERNAL_GA_PATH): New variable, using the system
    libglobalarrays-dev library.

 -- Michael Banck <mbanck@debian.org>  Tue, 01 Jan 2019 23:36:31 +0100

nwchem (6.8+47+gitdf6c956-4) unstable; urgency=medium

  * debian/patches/20_glibc-2.28_fix.patch: New patch, replaces loff_t with
    off_t, taken from upstream commit 6f6865a8. Closes: #916048.

 -- Michael Banck <mbanck@debian.org>  Wed, 12 Dec 2018 14:29:18 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,9 @@
                csh,
                debhelper (>= 7.0.50~),
                gfortran,
+               libarmci-mpi-dev,
                libblas-dev,
+               libglobalarrays-dev (>= 5.7-4),
                liblapack-dev,
                libscalapack-mpi-dev (>= 2),
                mpi-default-bin,

=== debian/rules ===
--- 
+++ 
@@ -15,25 +15,22 @@
 
 ifeq ($(DEB_HOST_ARCH_BITS),64)
 export NWCHEM_TARGET=LINUX64
-export USE_SCALAPACK_I8="yes"
-export BLAS_SIZE=4
-export SCALAPACK=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
-export BLAS_LIB="-lblas"
-export LAPACK_LIB="-llapack"
 export USE_64TO32="yes"
 else
 export NWCHEM_TARGET=LINUX
+endif
+export BLAS_SIZE=4
 export BLAS_LIB="-lblas"
 export LAPACK_LIB="-llapack"
 export USE_SCALAPACK="yes"
 export SCALAPACK=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
-endif
 ifeq ($(DEB_HOST_ARCH),armhf)
 export GCC49_ARM_BROKEN="yes"
 endif
 export NWCHEM_TOP=${CURDIR}
 export NWCHEM_MODULES="pnnl"
 export NWCHEM_LONG_PATHS="y"
+export EXTERNAL_GA_PATH=/usr
 export PYTHONVERSION=$(shell pyversions -dv)
 export PYTHONHOME=$(shell python-config --prefix)
 export LIBDIR=${NWCHEM_TOP}/lib/${NWCHEM_TARGET}
@@ -62,8 +59,6 @@
 export BLASOPT=-lblas -llapack
 export BLACS=$(SCALAPACK)
 export ARMCI_NETWORK=SOCKETS
-export GA_COPT=-g -O2
-export ARMCI_COPT=-g -O2
 export USE_ARUR="yes"
 
 %:
@@ -90,7 +85,7 @@
 	-(cd $(CURDIR)/doc && make realclean)
 	rm -rf $(CURDIR)/bin $(CURDIR)/lib $(CURDIR)/src/tools/lib 
 	rm -rf $(CURDIR)/QA/scratchdir $(CURDIR)/QA/testoutputs
-	rm -f src/util/util_version.F src/stubs.F src/util/util_module_avail.F
+	rm -f src/util/util_version.F src/stubs.F src/util/util_module_avail.F src/util/util_nwchem_version.F
 	find $(CURDIR) -name "*.stamp" | xargs rm -f
 	dh_auto_clean
 	rm -f src/config/NWCHEM_CONFIG src/config/nwchem_config.h

=== debian/watch ===
version=3 
https://github.com/nwchemgit/nwchem/releases .*/archive/([\d.]+)-release\.tar\.(?:bz2|gz)
